import { CATEGORIES, USER_ROLES } from '@/consts'

export type Category = typeof CATEGORIES[number]

export type Post = {
    id:         number
    url:        string
    title:      string
    thumbnail:  string
    tags:       Tag[]
    viewed:     boolean }

export type Tag = {
    id:       number
    name:     string
    category: Category
    count?:   number}

export type User = {
    id:               number
    name:             string | null
    inheritanceCode:  string
    role:             UserRole }

export type WikiPage = {
    id:           number
    title:        string
    sha:          string
    pred?:        string
    succ?:        string
    updated_at?:  string }

export type WikiPageChange = {
    sha:          string
    pred?:        string
    succ?:        string
    wiki_page:    WikiPage
    user:         User
    change_type:  string
    timestamp:    string }

export type WikiPageDiff = {
    wiki_page_id: number
    title:        string
    older_sha:    string
    newer_sha:    string
    diff:         WikiPageDiffDiff[] }

export type WikiPageDiffDiff = {
    type:     'context' | 'added' | 'removed'
    content:  string }

export type UserRole = typeof USER_ROLES[number]
